/* Fitxer: prov2.h
   Descripci: Definici del tipus de dada "provincia" i declaraci de les funcions
               per gestionar-lo.
   Autor: Isidre Guix
*/

#ifndef __PROV__H__
#define __PROV__H__

struct t_prov
{
	unsigned int codPais;
	unsigned int codProv;
	char nomProv[30];
};

void pantallaProv (void);
/* Disseny de pantalla que situa els ttols dels camps de provncia.
   Es pot utilitzar per efectuar la lectura dels valors pel teclat 
   i la visualitzaci per pantalla */

void inputCodPaisProv (struct t_prov *);
/* Efectua la lectura del codi de pas d'una provncia (noms camp codPais) en 
   coordenades coherents amb les de pantallaProv()
*/

void inputCodProv (struct t_prov *);
/* Efectua la lectura del codi d'una provncia (noms camp codProv) en coordenades
   coherents amb les de pantallaProv()
*/

void inputInfProv (struct t_prov *);
/* Efectua la lectura de la informaci d'una provncia que no es correspon amb els
   camps que la identifiquen -codPais i codProv-, en coordenades coherents amb 
   les de pantallaProv()
*/

void outputProvFor (struct t_prov);
/* Mostra la informaci d'una provncia per la sortida estndard, en format formulari, 
   en coordenades coherents amb les de pantallaProv()
*/

void outputProvTab (unsigned char fil, struct t_prov);
/* Mostra la informaci d'una provncia per la sortida estndard, en format tabular, 
   a la fila que indica l'argument "fil"
*/

/******************************************************
	Funcionalitats afegides en pais2.h respecte pais1.h
*******************************************************/

void outputNomPais (char *nomPais);
/* Mostra el nom del pas per la sortida estndard, en coordenades coherents amb
   les de pantallaProv()
*/

void outputInfProv (struct t_prov);
/* Mostra la informaci (no els camps que identifiquen) d'una provncia, per la 
   sortida estndard, en coordenades coherents amb les de pantallaProv()
*/

#endif
