/* Programa: u6n2a01.c
	Descripci: Programa per gestionar els fitxers Btrieve PAIS.BTR i PROV.BTR
	Autor: Isidre Guix
*/

#include <string.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#include "turcbtrv.c"

#include "generic2.h"
#include "pais1.h"
#include "prov2.h"

#define PAPER 65	/* Llargada de paper a la impressora. Podria ser una pregunta */

/*******************************************************
 Variables a utilitzar per la gesti dels fitxers Btrieve
********************************************************/

char fpais[128],fprov[128];
int lpais,lprov;
struct t_pais rpais;
struct t_prov rprov;
unsigned int pais0;	/* Clau 0 del fitxer PAIS.BTR */
char pais1[30];		/* Clau 1 del fitxer PAIS.BTR */
struct t_prov0 { unsigned int codPais, codProv; } prov0;	/* Clau 0 del fitxer PROV.BTR */
struct t_prov1 { unsigned int codPais; char nomProv[30]; } prov1;  /* Clau 1 del fitxer PROV.BTR */

/**************************************************************
 Funcions d'utilitzaci genrica que estarien
 millor dins del fitxer generic1.c (prototipus dins generic1.h)
 per que no s'hi han posat per no treure una nova versi dels
 fitxers generic.h i generic.c.
**************************************************************/

void centrar(char *s, int l)
{
	char cadena[80];
	int k;
	if (l>79) l=79;
	k=strlen(s);
	cadena[0]='\0';
	while (strlen(cadena)<(l-k)/2) strcat(cadena," ");
	strcat(cadena,s);
	while (strlen(cadena)<l) strcat(cadena," ");
	strncpy(s,cadena,80);
}

void titol(char *s)
{
	window(1,1,80,4);textattr(27);clrscr();
	centrar(s,79);	gotoxy(1,1); cputs(s);
}

/**************************************************************
 Funcions directament dissenyades pel programa en curs.
**************************************************************/

void obrir_fitxer(char *file, const char *nom, char *r, int *l)
{
	int error;

	error=BTRV(0,file,r,l,nom,0);
	if (error)
	{
		char s[80];
		sprintf(s,"Error %d en obrir el fitxer %s",error,nom);
		missatge_ae(s);
		exit(1);
	}
}

void tancar_fitxer(char *file, char *nom)
{
	int error;
	error=BTRV(1,file);
	if (error)
	{
		char s[80];
		sprintf(s,"Error %d en tancar el fitxer %s",error,nom);
		missatge_ae(s);
		exit(1);
	}
}

void altes_pais()
{
	int error;
	char opc;

	do
	{	pantallaPais();
		inputCodPais (&rpais);
		pais0=rpais.codPais;
		error=BTRV(5,fpais,&rpais,&lpais,&pais0,0);
		switch(error)
		{	case 0: outputPaisFor(rpais);
					  missatge_ae ("Ja existeix un pais amb aquest codi. ");
					  break;
			case 4: inputInfPais(&rpais);
					  pregunta ("Vol gravar-lo?", &opc, "SN");
					  if (opc == 'S')
					  {	error = BTRV(2,fpais,&rpais,&lpais,&pais0,0);
							switch (error)
							{	case 0: missatge_ae ("Inserci efectuada. "); break;
								case 5: missatge_ae ("Ja existeix un pas amb aquest codi o nom. ");
										  break;
								default: {	char s[80];
												sprintf(s,"Error %d en gravar pas. ",error);
												missatge_ae (s);
											}
							}
					  }
					  break;
			default:{	char s[80];
							sprintf(s,"Error %d en cercar pas. ",error);
							missatge_ae (s);
					  }
		}
		pregunta ("Vol afegir ms pasos?", &opc, "SN");
	} while (opc=='S');
}

int comprovar_pais(struct t_pais *rpais)
{
	pais0=rpais->codPais;
	return BTRV(5,fpais,rpais,&lpais,&pais0,0);
}

void altes_prov()
{
	int error;
	char opc;

	do
	{  pantallaProv();
		inputCodPaisProv (&rprov);
		rpais.codPais=rprov.codPais;
		if (comprovar_pais(&rpais)!=0)
			missatge_ae("Pas inexistent. ");
		else
		{
			outputNomPais (rpais.nomPais);
			inputCodProv (&rprov);
			prov0.codPais=rprov.codPais;
			prov0.codProv=rprov.codProv;
			error=BTRV(5,fprov,&rprov,&lprov,&prov0,0);
			switch(error)
			{	case 0: outputProvFor(rprov);
						  missatge_ae ("Ja existeix una provncia amb aquest codi. ");
						  break;
				case 4: inputInfProv(&rprov);
						  pregunta ("Vol gravar-la?", &opc, "SN");
						  if (opc == 'S')
						  {	error = BTRV(2,fprov,&rprov,&lprov,&prov0,0);
								switch (error)
								{	case 0: missatge_ae ("Inserci efectuada. "); break;
									case 5: missatge_ae ("Ja existeix una provncia amb aquest codi o nom. ");
											  break;
									default: {	char s[80];
													sprintf(s,"Error %d en gravar provncia. ",error);
													missatge_ae (s);
												}
								}
						  }
						  break;
				default:{	char s[80];
								sprintf(s,"Error %d en cercar provncia. ",error);
								missatge_ae (s);
						  }
			}
		}
		pregunta ("Vol afegir ms provncies?", &opc, "SN");
	} while (opc=='S');
}

void baixes_pais()
{
	int error;
	char opc;

	do
	{  pantallaPais();
		inputCodPais (&rpais);
		pais0=rpais.codPais;
		error=BTRV(5,fpais,&rpais,&lpais,&pais0,0);
		switch(error)
		{	case 4: missatge_ae ("No existeix cap pais amb aquest codi. ");
					  break;
			case 0: outputPaisFor (rpais);
					  pregunta ("Vol esborrar-lo?", &opc, "SN");
					  if (opc == 'S')
					  {   prov0.codPais=rpais.codPais;
							prov0.codProv=0;
							error = BTRV(9,fprov,&rprov,&lprov,&prov0,0);
							if (!error && prov0.codPais==rpais.codPais)
							{	pregunta ("Hi ha provncies associades. Esborrar-ho (T)ot o (R)es?",&opc,"TR");
								if (opc=='R') opc='N';
								else
								{	int errorx;
									opc='S';
									do
									{  errorx=BTRV(4,fprov,&rprov,&lprov,&prov0,0);
										if (!errorx)
											error=BTRV(6,fprov,&rprov,&lprov,&prov0,0);
									} while (!errorx && !error && prov0.codPais==rpais.codPais);
									if (errorx)
									{
										char s[80];
										sprintf (s, "Error %d en esborrar provncia. No s'esborra res ms. ",errorx);
										opc='N';
									}
									if (error && error!=9)
									{
										char s[80];
										sprintf (s, "Error %d en cercar provncies. No s'esborra res ms. ",error);
										opc='N';
									}
								}
							}
					  }
					  if (opc == 'S')
					  {
							error = BTRV(4,fpais,&rpais,&lpais,&pais0,0);
							switch (error)
							{	case 0: missatge_ae ("Esborrat efectuat. "); break;
								case 4: missatge_ae ("Ja no existeix el pas a esborrar. ");
										  break;
								default: {	char s[80];
												sprintf(s,"Error %d en esborrar pas. ",error);
												missatge_ae (s);
											}
							}
					  }
					  break;
			default:{	char s[80];
							sprintf(s,"Error %d en cercar pas. ",error);
							missatge_ae (s);
					  }
		}
		pregunta ("Vol esborrar ms pasos?", &opc, "SN");
	} while (opc=='S');
}

void baixes_prov()
{
	int error;
	char opc;

	do
	{  pantallaProv();
		inputCodPaisProv (&rprov);
		rpais.codPais=rprov.codPais;
		if (comprovar_pais(&rpais)!=0)
			missatge_ae("Pas inexistent. ");
		else
		{
			outputNomPais (rpais.nomPais);
			inputCodProv (&rprov);
			prov0.codPais=rprov.codPais;
			prov0.codProv=rprov.codProv;
			error=BTRV(5,fprov,&rprov,&lprov,&prov0,0);
			switch(error)
			{	case 4: missatge_ae ("No existeix cap provncia amb aquest codi. ");
						  break;
				case 0: outputProvFor (rprov);
						  pregunta ("Vol esborrar-la?", &opc, "SN");
						  if (opc == 'S')
						  {	error = BTRV(4,fprov,&rprov,&lprov,&prov0,0);
								switch (error)
								{	case 0: missatge_ae ("Esborrat efectuat. "); break;
									case 4: missatge_ae ("Ja no existeix la provncia a esborrar. ");
											  break;
									default: {	char s[80];
													sprintf(s,"Error %d en esborrar provncia. ",error);
													missatge_ae (s);
												}
								}
						  }
						  break;
				default:{	char s[80];
								sprintf(s,"Error %d en cercar provncia. ",error);
								missatge_ae (s);
						  }
			}
		}
		pregunta ("Vol esborrar ms provncies?", &opc, "SN");
	} while (opc=='S');
}

void modificacions_pais()
{
	int error;
	char opc;

	do
	{  pantallaPais();
		inputCodPais (&rpais);
		pais0 = rpais.codPais;
		error=BTRV(5,fpais,&rpais,&lpais,&pais0,0);
		switch(error)
		{	case 4: missatge_ae ("No existeix cap pas amb aquest codi. ");
					  break;
			case 0: outputPaisFor (rpais);
					  pregunta ("Vol modificar-lo?", &opc, "SN");
					  if (opc == 'S')
					  {   inputInfPais (&rpais);
							pregunta ("Vol gravar les modificacions?", &opc, "SN");
							if (opc == 'S')
							{	error = BTRV(3,fpais,&rpais,&lpais,&pais0,0);
								switch (error)
								{	case 0: missatge_ae ("Modificaci efectuada. "); break;
									case 4: missatge_ae ("Ja no existeix el pas a modificar. ");
											  break;
									default: {	char s[80];
													sprintf(s,"Error %d en modificar pas. ",error);
													missatge_ae (s);
												}
								}
							}
					  }
					  break;
			default:{	char s[80];
							sprintf(s,"Error %d en cercar pas. ",error);
							missatge_ae (s);
					  }
		}
		pregunta ("Vol modificar ms pasos?", &opc, "SN");
	} while (opc=='S');
}

void modificacions_prov()
{
	int error;
	char opc;

	do
	{  pantallaProv();
		inputCodPaisProv (&rprov);
		rpais.codPais=rprov.codPais;
		if (comprovar_pais(&rpais)!=0)
			missatge_ae("Pas inexistent. ");
		else
		{
			outputNomPais (rpais.nomPais);
			inputCodProv (&rprov);
			prov0.codPais=rprov.codPais;
			prov0.codProv=rprov.codProv;
			error=BTRV(5,fprov,&rprov,&lprov,&prov0,0);
			switch(error)
			{	case 4: missatge_ae ("No existeix cap provncia amb aquest codi. ");
						  break;
				case 0: outputProvFor (rprov);
						  pregunta ("Vol modificar-la?", &opc, "SN");
						  if (opc == 'S')
						  {   inputInfProv (&rprov);
								pregunta ("Vol gravar les modificacions?", &opc, "SN");
								if (opc == 'S')
								{	error = BTRV(3,fprov,&rprov,&lprov,&prov0,0);
									switch (error)
									{	case 0: missatge_ae ("Modificaci efectuada. "); break;
										case 4: missatge_ae ("Ja no existeix la provncia a modificar. ");
												  break;
										default: {	char s[80];
														sprintf(s,"Error %d en modificar provncia. ",error);
														missatge_ae (s);
													}
									}
								}
						  }
						  break;
				default:{	char s[80];
								sprintf(s,"Error %d en cercar provncia. ",error);
								missatge_ae (s);
						  }
			}
		}
		pregunta ("Vol modificar ms provncies?", &opc, "SN");
	} while (opc=='S');
}

void consultes_pais()
{
	int error;
	char cOpcio,opc;
	void *clau;
	char s[80];
	int nClau;

	pregunta ("Per (c)odi o per (n)om? ",&cOpcio,"CN");
	do
	{
		pantallaPais();
		switch (cOpcio)
		{
			case 'C': nClau=0; clau=&pais0;
						 inputCodPais (&rpais);
						 pais0=rpais.codPais; break;
			case 'N': nClau=1; clau=pais1;
						 inputInfPais (&rpais);
						 strcpy(pais1,rpais.nomPais); break;
		}
		error=BTRV(5,fpais,&rpais,&lpais,clau,nClau);
		switch (error)
		{
			case 4: missatge_ae ("No existeix cap pas amb la dada demanada. ");
					  break;
			case 0: outputPaisFor (rpais);
					  missatge_ae ("Consulta efectuada. ");
					  break;
			default:{	char s[80];
							sprintf(s,"Error %d en cercar pas. ",error);
							missatge_ae (s);
					  }
		}
		switch (cOpcio)
		{	case 'C': pregunta ("Vol consultar ms pasos per codi?", &opc, "SN");
						 break;
			case 'N': pregunta ("Vol consultar ms pasos per nom?", &opc, "SN");
						 break;
		}
	} while (opc=='S');
}

void consultes_prov()
{
	int error;
	char cOpcio,opc;
	void *clau;
	char s[80];
	int nClau;

	pregunta ("Per (c)odi o per (n)om? ",&cOpcio,"CN");
	do
	{
		pantallaProv();
		inputCodPaisProv (&rprov);
		rpais.codPais=rprov.codPais;
		if (comprovar_pais(&rpais)!=0)
			missatge_ae("Pas inexistent. ");
		else
		{
			outputNomPais (rpais.nomPais);
			switch (cOpcio)
			{
				case 'C': nClau=0; clau=&prov0;
							 inputCodProv (&rprov);
							 prov0.codPais=rprov.codPais;
							 prov0.codProv=rprov.codProv; break;
				case 'N': nClau=1; clau=&prov1;
							 inputInfProv (&rprov);
							 prov1.codPais=rprov.codPais;
							 strcpy(prov1.nomProv,rprov.nomProv); break;
			}
			error=BTRV(5,fprov,&rprov,&lprov,clau,nClau);
			switch (error)
			{
				case 4: missatge_ae ("No existeix cap provncia amb la dada demanada. ");
						  break;
				case 0: outputProvFor (rprov);
						  missatge_ae ("Consulta efectuada. ");
						  break;
				default:{	char s[80];
								sprintf(s,"Error %d en cercar provncia. ",error);
								missatge_ae (s);
						  }
			}
		}
		switch (cOpcio)
		{	case 'C': pregunta ("Vol consultar ms provncies per codi?", &opc, "SN");
						 break;
			case 'N': pregunta ("Vol consultar ms provncies per nom?", &opc, "SN");
						 break;
		}
	} while (opc=='S');
}

void llispant_pais()
{
	char cOpcio;
	int error,lin;
	void *clau;
	char s[80];
	int nClau;

	pregunta ("Per (c)odi o per (n)om? ",&cOpcio,"CN");
	clrscr();
	switch (cOpcio)
	{
		case 'C': nClau=0; clau=&pais0;
					 strcpy(s,"LLISTAT DE PASOS CLASSIFICATS PER CODI - ASCENDENTMENT");break;
		case 'N': nClau=1; clau=pais1;
					 strcpy(s,"LLISTAT DE PASOS CLASSIFICATS PER NOM - ASCENDENTMENT");break;
	}
	titol(s);
	gotoxy(1,3); cputs("CODI  NOM");
	gotoxy(1,4); cputs("");
	lin=1; window(1,5,80,24); textattr(15); clrscr();
	error=BTRV(12,fpais,&rpais,&lpais,clau,nClau);
	while (!error)
	{
		if (lin==21)
		{
			window(1,1,80,25); missatge_ae("");
			lin=1; window(1,5,80,24); textattr(15); clrscr();
		}
		gotoxy (1,lin);printf("%5d %s",rpais.codPais,rpais.nomPais);
		error=BTRV(6,fpais,&rpais,&lpais,clau,nClau);
		lin++;
	}
	window(1,1,80,25);
	if (error!=9)
	{
		char s[80];
		sprintf(s,"Error %d en consultar el fitxer PAIS.BTR   ",error);
		missatge_ae(s);
	}
	else
	{
		missatge_ae("Final dels registres al fitxer PAIS.BTR   ");
	}
}

void llispant_prov()
{
	char cOpcio,cUnTots;
	int error,lin;
	void *clau;
	char s[80];
	int nClau;

	pregunta ("D'(u)n pas o de (t)ots els pasos? ",&cUnTots,"UT");
	if (cUnTots=='U')
	{
		pantallaPais();
		inputCodPais(&rpais);
		if (comprovar_pais(&rpais)!=0)
		{	error=1;
			missatge_ae("Pas inexistent. ");
		}
		else
		{  outputPaisFor (rpais);
			pregunta ("s aquest el pas del qual vol el llistat? ",&cOpcio,"SN");
			error=(cOpcio=='N');
		}
	}
	else {error=0; rpais.codPais=0; }

	if (error) return;

	pregunta ("Per (c)odi o per (n)om? ",&cOpcio,"CN");
	clrscr();
	switch (cOpcio)
	{
		case 'C': nClau=0; clau=&prov0;
					 strcpy(s,"LLISTAT DE PROVNCIES CLASSIFICADES PER PAIS-CODI - ASCENDENTMENT");
					 prov0.codPais=rpais.codPais;
					 prov0.codProv=0;
					 break;
		case 'N': nClau=1; clau=&prov1;
					 strcpy(s,"LLISTAT DE PROVNCIES CLASSIFICADES PER PAIS-NOM - ASCENDENTMENT");
					 prov1.codPais=rpais.codPais;
					 strcpy(prov1.nomProv,"");
					 break;
	}
	titol(s);
	gotoxy(1,3); cputs("PAIS  CODI  NOM");
	gotoxy(1,4); cputs("");
	lin=1; window(1,5,80,24); textattr(15); clrscr();
	error=BTRV(9,fprov,&rprov,&lprov,clau,nClau);
	while (!error && (rpais.codPais==0 || rprov.codPais==rpais.codPais))
	{
		if (lin==21)
		{
			window(1,1,80,25); missatge_ae("");
			lin=1; window(1,5,80,24); textattr(15); clrscr();
		}
		gotoxy (1,lin);printf("%5d %5d %s",rprov.codPais,rprov.codProv,rprov.nomProv);
		error=BTRV(6,fprov,&rprov,&lprov,clau,nClau);
		lin++;
	}
	window(1,1,80,25);
	if (error!=9)
	{
		char s[80];
		sprintf(s,"Error %d en consultar el fitxer PROV.BTR   ",error);
		missatge_ae(s);
	}
	else
	{
		missatge_ae("Final dels registres a llistar.   ");
	}
}

void nova_fulla(int *l, char *tit0, char *tit1, char *tit2)
{
	fprintf(stdprn,"\n\n");
	fprintf(stdprn,"*******************************************************************************\n");
	fprintf(stdprn,"%s\n",tit0);
	fprintf(stdprn,"*******************************************************************************\n");
	fprintf(stdprn,"\n");
	fprintf(stdprn,"%s\n",tit1);
	fprintf(stdprn,"%s\n\n",tit2);
	*l=9;
}

void llisimpr_pais()
{
	char cOpcio;
	int error,lin;
	char tit0[80],tit1[80],tit2[80];
	void *clau;
	char s[80];
	int nClau;

	pregunta ("Per (c)odi o per (n)om? ",&cOpcio,"CN");
	clrscr();
	switch (cOpcio)
	{
		case 'C': nClau=0; clau=&pais0;
					 strcpy(tit0,"LLISTAT DE PASOS CLASSIFICATS PER CODI - ASCENDENTMENT");break;
		case 'N': nClau=1; clau=pais1;
					 strcpy(tit0,"LLISTAT DE PASOS CLASSIFICATS PER NOM - ASCENDENTMENT");break;
	}
	centrar(tit0,79);
	strcpy(tit1,"CODI  NOM");
	strcpy(tit2,"-------------------------------------------------------------------------------");
	nova_fulla(&lin, tit0, tit1, tit2);
	error=BTRV(12,fpais,&rpais,&lpais,clau,nClau);
	while (!error)
	{
		if (lin==PAPER-3)
		{
			fprintf(stdprn,"\f");
			nova_fulla(&lin, tit0, tit1, tit2);
		}
		fprintf (stdprn, "%5d %s\n", rpais.codPais, rpais.nomPais);
		error=BTRV(6,fpais,&rpais,&lpais,clau,nClau);
		lin++;
	}
	if (error!=9)
	{
		char s[80];
		sprintf(s,"Error %d en consultar el fitxer PAIS.BTR   ",error);
		missatge_ae(s);
	}
	else
		fprintf(stdprn,"\n\nFi llistat*********************************************************************\f");
}

void llisimpr_prov()
{
	char cOpcio,cUnTots;
	int error,lin;
	char tit0[80],tit1[80],tit2[80];
	void *clau;
	char s[80];
	int nClau;

	pregunta ("D'(u)n pas o de (t)ots els pasos? ",&cUnTots,"UT");
	if (cUnTots=='U')
	{
		pantallaPais();
		inputCodPais(&rpais);
		if (comprovar_pais(&rpais)!=0)
		{	error=1;
			missatge_ae("Pas inexistent. ");
		}
		else
		{  outputPaisFor (rpais);
			pregunta ("s aquest el pas del qual vol el llistat? ",&cOpcio,"SN");
			error=(cOpcio=='N');
		}
	}
	else {error=0; rpais.codPais=0; }

	if (error) return;


	pregunta ("Per (c)odi o per (n)om? ",&cOpcio,"CN");
	clrscr();
	switch (cOpcio)
	{
		case 'C': nClau=0; clau=&prov0;
					 strcpy(tit0,"LLISTAT DE PROVNCIES CLASSIFICADES PER PAIS-CODI - ASCENDENTMENT");
					 prov0.codPais=rpais.codPais;
					 prov0.codProv=0;
					 break;
		case 'N': nClau=1; clau=&prov1;
					 strcpy(tit0,"LLISTAT DE PROVNCIES CLASSIFICADES PER PAIS-NOM - ASCENDENTMENT");
					 prov1.codPais=rpais.codPais;
					 strcpy(prov1.nomProv,"");
					 break;
	}
	centrar(tit0,79);
	strcpy(tit1,"PAIS  CODI  NOM");
	strcpy(tit2,"-------------------------------------------------------------------------------");
	nova_fulla(&lin, tit0, tit1, tit2);
	error=BTRV(9,fprov,&rprov,&lprov,clau,nClau);
	while (!error && (rpais.codPais==0 || rprov.codPais==rpais.codPais))
	{
		if (lin==PAPER-3)
		{
			fprintf(stdprn,"\f");
			nova_fulla(&lin, tit0, tit1, tit2);
		}
		fprintf (stdprn, "%5d %5d %s\n", rprov.codPais, rprov.codProv, rprov.nomProv);
		error=BTRV(6,fprov, &rprov,&lprov,clau,nClau);
		lin++;
	}
	if (error!=9)
	{
		char s[80];
		sprintf(s,"Error %d en consultar el fitxer PROV.BTR   ",error);
		missatge_ae(s);
	}
	else
		fprintf(stdprn,"\n\nFi llistat*********************************************************************\f");
}

char pantalla2(char opc)
{
	char cOpcio;

	clrscr();
	gotoxy( 22, 4 );
	cputs( "Ŀ" );
	gotoxy( 22, 5 );
	if (opc=='1')
		cputs( "      MANTENIMENT DE PASOS     " );
	else
		cputs( "    MANTENIMENT DE PROVNCIES   " );
	gotoxy( 22, 6 );
	cputs( "Ĵ" );
	gotoxy( 22, 7 );
	cputs( "   1. Altes                     " );
	gotoxy( 22, 8 );
	cputs( "   2. Baixes                    " );
	gotoxy( 22, 9 );
	cputs( "   3. Modificacions             " );
	gotoxy( 22, 10 );
	cputs( "   4. Consultes                 " );
	gotoxy( 22, 11 );
	cputs( "   5. Llistats per pantalla     " );
	gotoxy( 22, 12 );
	cputs( "   6. Llistats per impressora   " );
	gotoxy( 22, 13 );
	cputs( "                                " );
	gotoxy( 22, 14 );
	cputs( "   0. Sortir                    " );
	gotoxy( 22, 15 );
	cputs( "" );
	gotoxy( 26, 17 );
	cputs( "Premi opci:" );
	do
	{
	gotoxy( 39, 17 );cOpcio=getche();
	} while (cOpcio<'0' || cOpcio>'6');
	return cOpcio;
}

char pantalla1()
{
	char cOpcio;

	clrscr();
	gotoxy( 22, 5 );
	cputs( "Ŀ" );
	gotoxy( 22, 6 );
	cputs( "                                " );
	gotoxy( 22, 7 );
	cputs( "   1. Manteniment de Pasos     " );
	gotoxy( 22, 8 );
	cputs( "   2. Manteniment de Provncies " );
	gotoxy( 22, 9 );
	cputs( "                                " );
	gotoxy( 22, 10);
	cputs( "   0. Sortir                    " );
	gotoxy( 22, 11 );
	cputs( "                                " );
	gotoxy( 22, 12 );
	cputs( "" );
	gotoxy( 26, 17 );
	cputs( "Premi opci:" );
	do
	{
	gotoxy( 39, 17 );cOpcio=getche();
	} while (cOpcio<'0' || cOpcio>'2');
	return cOpcio;
}


void main(void)
{
	char cOpcio1,cOpcio2;
	clrscr();
	obrir_fitxer(fpais,"pais.btr",(char *)&rpais,&lpais);
	obrir_fitxer(fprov,"prov.btr",(char *)&rprov,&lprov);
	lpais=sizeof (struct t_pais);
	lprov=sizeof (struct t_prov);
	while ((cOpcio1=pantalla1())!='0')
	{
		if (cOpcio1!='0')
			while ((cOpcio2=pantalla2(cOpcio1))!='0')
			{
				switch (cOpcio1)
				{	case '1':	switch (cOpcio2)
									{
										case '1': altes_pais(); break;
										case '2': baixes_pais(); break;
										case '3': modificacions_pais(); break;
										case '4': consultes_pais(); break;
										case '5': llispant_pais(); break;
										case '6': llisimpr_pais(); break;
									}
									break;
					case '2':	switch (cOpcio2)
									{
										case '1': altes_prov(); break;
										case '2': baixes_prov(); break;
										case '3': modificacions_prov(); break;
										case '4': consultes_prov(); break;
										case '5': llispant_prov(); break;
										case '6': llisimpr_prov(); break;
									}
									break;
				}
			}
	}
	tancar_fitxer(fpais,"pais.btr");
	tancar_fitxer(fprov,"prov.btr");
	clrscr();
}