/* Programa: u6n2w01.c
	Descripci: Programa per gestionar el fitxer PERSONES.BTR
	Autor: Isidre Guix
*/

#include <string.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#include "turcbtrv.c"

#include "generic2.h"
#include "persona2.h"

#define PAPER 65	/* Llargada de paper a la impressora. Podria ser una pregunta */

/******************************************************
 Variables a utilitzar per la gesti del fitxer Btrieve
*******************************************************/

char fcl[128];
int lper;
struct t_persona rper;
char clau0[10];
struct t_clau1 { char c1[21], c2[21], n[16]; } clau1;
struct t_data clau2;
char nom[]="PERSONES.BTR";

/**************************************************************
 Funcions necessaries per gestionar persones, que estarien
 millor dins del fitxer persona2.c (prototipus dins persona2.h)
 per que no s'hi han posat per no treure una nova versi dels
 fitxers persona.h i persona.c.
**************************************************************/

void modificar_camps (struct t_persona *p)
/* Funci que permet modificar selectivament els camps d'una persona
	excepte el seu nif */
{
	unsigned char i,opc;
	long auxlong;

	gotoxy(19,10); puts ("1");
	gotoxy(19,12); puts ("2");
	gotoxy(19,14); puts ("3");
	gotoxy(19,16); puts ("4");
	gotoxy(19,18); puts ("5");
	gotoxy(19,20); puts ("6");
	do
	{	pregunta ("Camp a modificar (0:Finalitzar)? ",&opc,"0123456");
		switch (opc)
		{	case '1':do
						{ gotoxy(40,10); printf("%20s",""); gotoxy(40,10);
						  i = scanf ("%20s",p->cognom1); fflush (stdin); }
						while (i == 0);
						break;
			case '2':do
						{ gotoxy(40,12); printf("%20s",""); gotoxy(40,12);
						  i = scanf ("%20s",p->cognom2); fflush (stdin); }
						while (i == 0);
						break;
			case '3':do
						{ gotoxy(40,14); printf("%15s",""); gotoxy(40,14);
						  i = scanf ("%15s",p->nom); fflush (stdin); }
						while (i == 0);
						break;
			case '4':missatge_se("Format dd-mm-aaaa amb separador '.', '-' o '/'");
						do
						{ gotoxy(40,16); printf("%10s",""); gotoxy(40,16);
						  i = inputData (&(p->data_naix)); fflush (stdin); }
						while (i == 0);
						netejar_missatge();
						break;
			case '5':missatge_se("Valor positiu   -   0->Si s desconegut");
						do
						{ gotoxy(40,18); printf("%10s",""); gotoxy(40,18);
						  i = scanf ("%g",&(p->pes)); fflush (stdin); }
						while (i == 0 || p->pes<0);
						netejar_missatge();
						break;
			case '6':missatge_se("Valor positiu fins a 255");
						do
						{ gotoxy(40,20); printf("%10s",""); gotoxy(40,20);
						  i = scanf ("%u",&auxlong); fflush (stdin); }
						while (i == 0 || auxlong<0 || auxlong>255);
						p->alt=auxlong;	netejar_missatge(); break;
		}
	} while (opc!='0');
}

void get_cognoms_nom (struct t_clau1 *ccn)
/* Funci que permet efectuar l'entrada dels cognoms i noms de la persona */
{
	int i;

	do
	{ gotoxy(40,10); i = scanf ("%20s",ccn->c1); fflush (stdin); }
	while (i == 0);
	do
	{ gotoxy(40,12); i = scanf ("%20s",ccn->c2); fflush (stdin); }
	while (i == 0);
	do
	{ gotoxy(40,14); i = scanf ("%15s",ccn->n); fflush (stdin); }
	while (i == 0);
}

int igual_ccn (struct t_clau1 c1, struct t_clau1 c2)
/* Funci que permet comparar els cognoms i nom de dues persones.
	Retorna 0 si no sn iguals i diferent de zero si sn iguals */
{
	return !strcmp(c1.c1,c2.c1) && !strcmp(c1.c2,c2.c2) && !strcmp(c1.n,c2.n);
}

/**************************************************************
 Funcions d'utilitzaci genrica que estarien
 millor dins del fitxer generic2.c (prototipus dins generic2.h)
 per que no s'hi han posat per no treure una nova versi dels
 fitxers generic.h i generic.c.
**************************************************************/

void centrar(char *s, int l)
{
	char cadena[80];
	int k;
	if (l>79) l=79;
	k=strlen(s);
	cadena[0]='\0';
	while (strlen(cadena)<(l-k)/2) strcat(cadena," ");
	strcat(cadena,s);
	while (strlen(cadena)<l) strcat(cadena," ");
	strncpy(s,cadena,80);
}

void titol(char *s)
{
	window(1,1,80,4);textattr(27);clrscr();
	centrar(s,79);	gotoxy(1,1); cputs(s);
}

/**************************************************************
 Funcions directament dissenyades pel programa en curs.
**************************************************************/

void obrir_fitxer()
{
	int error;

	error=BTRV(0,fcl,&rper,&lper,nom,0);
	if (error==20)
	{
		missatge_ae("SGF Btrieve no carregat! ");
		exit(1);
	}
	if (error)
	{
		char s[80];
		sprintf(s,"Error %d en obrir el fitxer %s. ",error,nom);
		missatge_ae(s);
		exit(1);
	}
}

void tancar_fitxer()
{
	int error;
	error=BTRV(1,fcl);
	if (error)
	{
		char s[80];
		sprintf(s,"Error %d en tancar el fitxer %s. ",error,nom);
		missatge_ae(s);
		exit(1);
	}
}

void altes()
{
	int error;
	char opc;

	do
	{	pantallaPersona ();
		inputNif (clau0,8,40);
		lper=sizeof(struct t_persona);
		error=BTRV(5,fcl,&rper,&lper,clau0,0);
		switch(error)
		{	case 0: outputPersonaFor(rper);
					  missatge_ae ("Ja existeix una persona amb aquest NIF. ");
					  break;
			case 4: inputPersonaSenseNif (&rper);
					  strcpy(rper.nif,clau0);
					  pregunta ("Vol gravar-la?", &opc, "SN");
					  if (opc == 'S')
					  {	error = BTRV(2,fcl,&rper,&lper,clau0,0);
							switch (error)
							{	case 0: missatge_ae ("Inserci efectuada. "); break;
								case 5: missatge_ae ("Ja existeix una persona amb aquest NIF. ");
										  break;
								default: {	char s[80];
												sprintf(s,"Error %d en gravar persona. ",error);
												missatge_ae (s);
											}
							}
					  }
					  break;
			default:{	char s[80];
							sprintf(s,"Error %d en cercar persona. ",error);
							missatge_ae (s);
					  }
		}
		pregunta ("Vol afegir ms persones?", &opc, "SN");
	} while (opc=='S');
}

void baixes()
{
	int error;
	char opc;

	do
	{	pantallaPersona ();
		inputNif (clau0,8,40);
		lper=sizeof(struct t_persona);
		error=BTRV(5,fcl,&rper,&lper,clau0,0);
		switch(error)
		{	case 4: missatge_ae ("No existeix cap persona amb aquest NIF. ");
					  break;
			case 0: outputPersonaFor (rper);
					  pregunta ("Vol esborrar-la?", &opc, "SN");
					  if (opc == 'S')
					  {	error = BTRV(4,fcl,&rper,&lper,clau0,0);
							switch (error)
							{	case 0: missatge_ae ("Esborrat efectuat. "); break;
								case 4: missatge_ae ("Ja no existeix la persona a esborrar. ");
										  break;
								default: {	char s[80];
												sprintf(s,"Error %d en esborrar persona. ",error);
												missatge_ae (s);
											}
							}
					  }
					  break;
			default:{	char s[80];
							sprintf(s,"Error %d en cercar persona. ",error);
							missatge_ae (s);
					  }
		}
		pregunta ("Vol esborrar ms persones?", &opc, "SN");
	} while (opc=='S');
}

void modificacions()
{
	int error;
	char opc;

	do
	{	pantallaPersona ();
		inputNif (clau0,8,40);
		lper=sizeof(struct t_persona);
		error=BTRV(5,fcl,&rper,&lper,clau0,0);
		switch(error)
		{	case 4: missatge_ae ("No existeix cap persona amb aquest NIF. ");
					  break;
			case 0: outputPersonaFor (rper);
					  pregunta ("Vol modificar-la?", &opc, "SN");
					  if (opc == 'S')
					  {   modificar_camps (&rper);
							pregunta ("Vol gravar les modificacions?", &opc, "SN");
							if (opc == 'S')
							{	error = BTRV(3,fcl,&rper,&lper,clau0,0);
								switch (error)
								{	case 0: missatge_ae ("Modificaci efectuada. "); break;
									case 4: missatge_ae ("Ja no existeix la persona a modificar. ");
											  break;
									default: {	char s[80];
													sprintf(s,"Error %d en modificar persona. ",error);
													missatge_ae (s);
												}
								}
							}
					  }
					  break;
			default:{	char s[80];
							sprintf(s,"Error %d en cercar persona. ",error);
							missatge_ae (s);
					  }
		}
		pregunta ("Vol modificar ms persones?", &opc, "SN");
	} while (opc=='S');
}

char menu_consultes()
{
	char cOpcio;

	window(1,1,80,25);textattr(15);clrscr();
	gotoxy( 19, 5 );
	cputs( "Ŀ" );
	gotoxy( 19, 6 );
	cputs( "                                           " );
	gotoxy( 19, 7 );
	cputs( "     CONSULTA DE PERSONES PER PANTALLA     " );
	gotoxy( 19, 8 );
	cputs( "Ĵ" );
	gotoxy( 19, 9 );
	cputs( "                                           " );
	gotoxy( 19, 10 );
	cputs( "  1. Per NIF                               " );
	gotoxy( 19, 11 );
	cputs( "  2. Per COGNOMS-NOM                       " );
	gotoxy( 19, 12 );
	cputs( "  3. Per DATA DE NAIXEMENT                 " );
	gotoxy( 19, 13 );
	cputs( "  0. Sortir                                " );
	gotoxy( 19, 14 );
	cputs( "                                           " );
	gotoxy( 19, 15 );
	cputs( "     Premi Opci:                          " );
	gotoxy( 19, 16 );
	cputs( "" );
	do
	{
	gotoxy( 38, 15 );cOpcio=getche();
	} while (cOpcio<'0' || cOpcio>'3');
	return cOpcio;
}

void consultes()
{
	int error;
	char cOpcio,opc;

	lper=sizeof(struct t_persona);
	while ((cOpcio=menu_consultes())!='0')
	{
		void *clau;
		char s[80];
		int nClau;
		do
		{
			pantallaPersona();
			switch (cOpcio)
			{
				case '1': nClau=0; clau=clau0;
							 gotoxy(22,5); puts("      CONSULTA DE PERSONES PER NIF     ");
							 inputNif(clau0,8,40); break;
				case '2': nClau=1; clau=&clau1;
							 gotoxy(22,5); puts("  CONSULTA DE PERSONES PER COGNOMS-NOM ");
							 get_cognoms_nom (&clau1); break;
				case '3': nClau=2; clau=&clau2;
							 gotoxy(22,5); puts("CONSULTA DE PERSONES PER DATA NAIXEMENT");
							 gotoxy(40,16); inputData(&clau2); break;
			}
			error=BTRV(5,fcl,&rper,&lper,clau,nClau);
			switch (error)
			{
				case 4: missatge_ae ("No existeix cap persona amb la dada demanada. ");
						  break;
				case 0: outputPersonaFor (rper);
						  if (nClau==0)
								missatge_ae ("Consulta efectuada. ");
						  else
						  {	do
								{	pregunta ("Intentem trobar-ne ms? ", &opc, "SN");
									if (opc=='S')
									{
										struct t_clau1 aux1=clau1;
										struct t_data aux2=clau2;
										error=BTRV(6,fcl,&rper,&lper,clau,nClau);
										if (!error && \
											((nClau==1 && igual_ccn(clau1,aux1)) || \
											 (nClau==2 && compararDates(clau2,aux2))))
											outputPersonaFor (rper);
										else
										{	missatge_ae ("No s'ha trobat cap altra persona. ");
											opc='N';
										}
									}
								}	while (opc=='S');
						  }
						  break;
				default:{	char s[80];
								sprintf(s,"Error %d en cercar persona. ",error);
								missatge_ae (s);
						  }
			}
			switch (cOpcio)
			{	case '1': pregunta ("Vol consultar ms persones per NIF?", &opc, "SN");
							 break;
				case '2': pregunta ("Vol consultar ms persones per COGNOMS-NOM?", &opc, "SN");
							 break;
				case '3': pregunta ("Vol consultar ms persones per DATA DE NAIXEMENT?", &opc, "SN");
							 break;
			}
		} while (opc=='S');
	}
}

char menu_llistats(char sortida)
{
	char cOpcio;

	window(1,1,80,25);textattr(15);clrscr();
	gotoxy( 19, 5 );
	cputs( "Ŀ" );
	gotoxy( 19, 6 );
	cputs( "                                           " );
	gotoxy( 19, 7 );
	if (sortida=='P')
		cputs( "     LLISTATS DE PERSONES PER PANTALLA     " );
	else
		cputs( "    LLISTATS DE PERSONES PER IMPRESSORA    " );
	gotoxy( 19, 8 );
	cputs( "Ĵ" );
	gotoxy( 19, 9 );
	cputs( "                                           " );
	gotoxy( 19, 10 );
	cputs( "  1. Classificats per NIF                  " );
	gotoxy( 19, 11 );
	cputs( "  2. Classificats per COGNOMS-NOM          " );
	gotoxy( 19, 12 );
	cputs( "  3. Classificats per DATA DE NAIXEMENT    " );
	gotoxy( 19, 13 );
	cputs( "  0. Sortir                                " );
	gotoxy( 19, 14 );
	cputs( "                                           " );
	gotoxy( 19, 15 );
	cputs( "     Premi Opci:                          " );
	gotoxy( 19, 16 );
	cputs( "" );
	do
	{
	gotoxy( 38, 15 );cOpcio=getche();
	} while (cOpcio<'0' || cOpcio>'3');
	return cOpcio;
}

void ll_pantalla()
{
	char cOpcio;
	int error,lin;

	while ((cOpcio=menu_llistats('P'))!='0')
	{
		void *clau;
		char s[80];
		int nClau;
		clrscr();
		switch (cOpcio)
		{
			case '1': nClau=0; clau=clau0;
						 strcpy(s,"LLISTAT PERSONES CLASSIFICADES PER NIF - ASCENDENTMENT"); break;
			case '2': nClau=1; clau=&clau1;
						 strcpy(s,"LLISTAT PERSONES CLASSIFICADES PER COGNOMS-NOM - ASCENDENTMENT");break;
			case '3': nClau=2; clau=&clau2;
						 strcpy(s,"LLISTAT PERSONES CLASSIFICATS PER DATA NAIXEMENT - DESCENDENTMENT");break;
		}
		titol(s);
		gotoxy(1,3); cputs("NIF       COGNOM 1             COGNOM 2             NOM            D.NAIXEMENT  ");
		gotoxy(1,4); cputs("");
		lin=1; window(1,5,80,24); textattr(15); clrscr();
		error=BTRV(12,fcl,&rper,&lper,clau,nClau);
		while (!error)
		{
			if (lin==21)
			{
				window(1,1,80,25); missatge_ae("");
				lin=1; window(1,5,80,24); textattr(15); clrscr();
			}
			outputPersonaTab(lin,rper);
			error=BTRV(6,fcl,&rper,&lper,clau,nClau);
			lin++;
		}
		window(1,1,80,25);
		if (error!=9)
		{
			char s[80];
			sprintf(s,"Error %d en consultar el fitxer %s. ",error,nom);
			missatge_ae(s);
		}
		else
		{
			char s[80];
			sprintf(s,"Final dels registres al fitxer %s. ",nom);
			missatge_ae(s);
		}
	}
}

void nova_fulla(int *l, char *tit0, char *tit1, char *tit2)
{
	fprintf(stdprn,"\n\n");
	fprintf(stdprn,"*******************************************************************************\n");
	fprintf(stdprn,"%s\n",tit0);
	fprintf(stdprn,"*******************************************************************************\n");
	fprintf(stdprn,"\n");
	fprintf(stdprn,"%s\n",tit1);
	fprintf(stdprn,"%s\n\n",tit2);
	*l=9;
}

void ll_impressora()
{
	char cOpcio;
	int error,lin;
	char tit0[80],tit1[80],tit2[80];

	while ((cOpcio=menu_llistats('I'))!='0')
	{
		void *clau;
		char s[80];
		int nClau;
		clrscr();
		switch (cOpcio)
		{
			case '1': nClau=0; clau=clau0;
						 strcpy(tit0,"LLISTAT PERSONES CLASSIFICADES PER NIF - ASCENDENTMENT");break;
			case '2': nClau=1; clau=&clau1;
						 strcpy(tit0,"LLISTAT PERSONES CLASSIFICADES PER COGNOMS-NOM - ASCENDENTMENT");break;
			case '3': nClau=2; clau=&clau2;
						 strcpy(tit0,"LLISTAT PERSONES CLASSIFICATS PER DATA NAIXEMENT - DESCENDENTMENT");break;
		}
		centrar(tit0,79);
		strcpy(tit1,"NIF       COGNOM 1             COGNOM 2             NOM            D.NAIXEMENT ");
		strcpy(tit2,"-------------------------------------------------------------------------------");

		nova_fulla(&lin, tit0, tit1, tit2);
		error=BTRV(12,fcl,&rper,&lper,clau,nClau);
		while (!error)
		{
			if (lin==PAPER-3)
			{
				fprintf(stdprn,"\f");
				nova_fulla(&lin, tit0, tit1, tit2);
			}
			fprintf (stdprn, "%-9s %-20s %-20s %-15s ", rper.nif, rper.cognom1, rper.cognom2, rper.nom);
			fprintf (stdprn, "%02d-%02d-%04d\n", rper.data_naix.dia, rper.data_naix.mes, rper.data_naix.any);
			error=BTRV(6,fcl,&rper,&lper,clau,nClau);
			lin++;
		}
		if (error!=9)
		{
			char s[80];
			sprintf(s,"Error %d en consultar el fitxer %s. ",error,nom);
			missatge_ae(s);
		}
		else
		{
			fprintf(stdprn,"\n\nFi llistat*********************************************************************\f");
		}
	}
}

char pantalla()
{
	char cOpcio;

	clrscr();
	gotoxy( 22, 4 );
	cputs( "Ŀ" );
	gotoxy( 22, 5 );
	cputs( "   MANTENIMENT DE PERSONES.BTR  " );
	gotoxy( 22, 6 );
	cputs( "Ĵ" );
	gotoxy( 22, 7 );
	cputs( "   1. Altes                     " );
	gotoxy( 22, 8 );
	cputs( "   2. Baixes                    " );
	gotoxy( 22, 9 );
	cputs( "   3. Modificacions             " );
	gotoxy( 22, 10 );
	cputs( "   4. Consultes                 " );
	gotoxy( 22, 11 );
	cputs( "   5. Llistats per pantalla     " );
	gotoxy( 22, 12 );
	cputs( "   6. Llistats per impressora   " );
	gotoxy( 22, 13 );
	cputs( "                                " );
	gotoxy( 22, 14 );
	cputs( "   0. Sortir                    " );
	gotoxy( 22, 15 );
	cputs( "" );
	gotoxy( 26, 17 );
	cputs( "Premi opci:" );
	do
	{
	gotoxy( 39, 17 );cOpcio=getche();
	} while (cOpcio<'0' || cOpcio>'6');
	return cOpcio;
}

void main(void)
{
	char cOpcio;
	clrscr();
	obrir_fitxer();
	lper=sizeof(rper);
	while ((cOpcio=pantalla())!='0')
	{
		switch (cOpcio)
		{
			case '1': altes(); break;
			case '2': baixes(); break;
			case '3': modificacions(); break;
			case '4': consultes(); break;
			case '5': ll_pantalla(); break;
			case '6': ll_impressora(); break;
		}
	}
	tancar_fitxer();
	clrscr();
}