/* Fitxer: generic2.h
	Descripci: Prototipus de funcions genriques a utilitzar en diferents programes.
	Autor: Isidre Guix
*/

#ifndef __GENERIC__H__
#define __GENERIC__H__

void missatge_ae (char *s);
/*  Funci que treu un missatge a la darrera lnia de la pantalla
	i espera a que l'usuari premi una tecla per continuar
   	Parmetres:
        s   Missatge a visualitzar
*/

void missatge_se (char *s);
/*	Funci que treu un missatge a la darrera lnia de la pantalla
   	Parmetres:
        s   Missatge a visualitzar
*/

void netejar_missatge(void);
/*	Funci que esborra la darrera lnia de la pantalla, destinada a missatges */

void pregunta (char *s, char *resp, char *valors);
/*	Funci que fa una pregunta a la darrera lnia de la pantalla
   	i espera una resposta d'un sol carcter, el qual s validat per
   	la mateixa funci
   	Parmetres:
        s       Text de la pregunta
        resp    Variable de tipus carcter que queda plena amb la resposta
        valors  Conjunt de carcters com a possible soluci
*/

void inputNif(char *nif, int fila, int columna);
/*  Funci que efectua la lectura per teclat d'un nif, passant-lo a majscules
    i, si s necessari, omplint-lo amb zeros per l'esquerra fins a 9 carcters.
    La lectura s'efectua en les coordenades indicades per fila-columna	
*/

#endif
