/* Fitxer: persona2.c
	Descripci: Definici de les funcions per gestionar el tipus "persona"
	Autor: Isidre Guix
*/

#include "persona2.h"
#include "conio.h"
#include "verscomp.h"
#include "generic2.h"
#include <stdio.h>
#include <string.h>

void pantallaPersona (void)
{
	clrscr();
	gotoxy( 17, 3 );	puts( "*************************************************" );
	gotoxy( 17, 4 );	puts( "*                                               *" );
	gotoxy( 17, 5 );	puts( "*       D A D E S   D E   P E R S O N A         *" );
	gotoxy( 17, 6 );	puts( "*************************************************" );
	gotoxy( 17, 7 );	puts( "*                                               *" );
	gotoxy( 17, 8 );	puts( "*    NIF..............                          *" );
	gotoxy( 17, 9 );	puts( "*                                               *" );
	gotoxy( 17, 10 );	puts( "*    Primer cognom....                          *" );
	gotoxy( 17, 11 );	puts( "*                                               *" );
	gotoxy( 17, 12 );	puts( "*    Segon cognom.....                          *" );
	gotoxy( 17, 13 );	puts( "*                                               *" );
	gotoxy( 17, 14 );	puts( "*    Nom..............                          *" );
	gotoxy( 17, 15 );	puts( "*                                               *" );
	gotoxy( 17, 16 );	puts( "*    Data naixement...                          *" );
	gotoxy( 17, 17 );	puts( "*                                               *" );
	gotoxy( 17, 18 );	puts( "*    Pes (kg).........                          *" );
	gotoxy( 17, 19 );	puts( "*                                               *" );
	gotoxy( 17, 20 );	puts( "*    Altura (cm)......                          *" );
	gotoxy( 17, 21 );	puts( "*                                               *" );
	gotoxy( 17, 22 );	puts( "*************************************************" );
}

void inputPersona (struct t_persona *p)
{
	unsigned char i;
	long auxlong;
	double auxdouble;
	
	pantallaPersona();
	do
	{ gotoxy(40,8); i = scanf ("%9s",p->nif); neteja_stdin(); }
	while (i == 0);
	strupr(p->nif);
	
	do
	{ gotoxy(40,10); i = scanf ("%20s",p->cognom1); neteja_stdin(); }
	while (i == 0);
	
	do
	{ gotoxy(40,12); i = scanf ("%20s",p->cognom2); neteja_stdin(); }
	while (i == 0);
	
	do
	{ gotoxy(40,14); i = scanf ("%15s",p->nom); neteja_stdin(); }
	while (i == 0);

	missatge_se("Format dd-mm-aaaa amb separador '.', '-' o '/'");
	do
	{ gotoxy(40,16); i = inputData (&(p->data_naix)); }
	while (i == 0);

	missatge_se("Valor positiu   -   0->Si s desconegut");
	do
	{ gotoxy(40,18); i = scanf ("%lf",&auxdouble); neteja_stdin(); }
	while (i == 0 || auxdouble<0);
	p->pes=auxdouble;
	/* L'anterior lectura s'ha de poder fer directament sobre &p->pes,
		per Turbo C++ no ho sap tractar correctament.
	   En canvi, utilitzant una variable auxiliar, el tractament s correcte */

	missatge_se("Valor positiu fins a 255   -   0->Si s desconegut");
	do
	{ gotoxy(40,20); i = scanf ("%lu",&auxlong); neteja_stdin(); }
	while (i == 0 || auxlong<0 || auxlong>255);
	p->alt=auxlong;
	/* En aquest cas, la utilitzaci de la variable auxlong s per recollir el valor
	   que introdueixi l'usuari, que pot ser superior a 255. Si ho fssim direc-
	   tament amb la variable &p->alt, en ser un unsigned char, si l'usuari entra
	   un valor superior a 255, el llenguatge C en fa el mdul 255 i es queda amb
	   el residu... No ens interessa!!! */

	netejar_missatge();
}

void inputPersonaNomesNif (struct t_persona *p)
{
	pantallaPersona();
	inputNif (p->nif, 8, 40);
	gotoxy(40,8); printf ("%s",p->nif);
}

void inputPersonaSenseNif (struct t_persona *p)
{
	unsigned char i;
	long auxlong;
	double auxdouble;

	do
	{ gotoxy(40,10); i = scanf ("%20s",p->cognom1); neteja_stdin(); }
	while (i == 0);
	
	do
	{ gotoxy(40,12); i = scanf ("%20s",p->cognom2); neteja_stdin(); }
	while (i == 0);
	
	do
	{ gotoxy(40,14); i = scanf ("%15s",p->nom); neteja_stdin(); }
	while (i == 0);

	missatge_se("Format dd-mm-aaaa amb separador '.', '-' o '/'");
	do
	{ gotoxy(40,16); i = inputData (&(p->data_naix)); }
	while (i == 0);

	missatge_se("Valor positiu   -   0->Si s desconegut");
	do
	{ gotoxy(40,18); i = scanf ("%lf",&auxdouble); neteja_stdin(); }
	while (i == 0 || auxdouble<0);
	p->pes=auxdouble;
	/* L'anterior lectura s'ha de poder fer directament sobre &p->pes,
	   per Turbo C++ no ho sap tractar correctament.
	   En canvi, utilitzant una variable auxiliar, el tractament s correcte */

	missatge_se("Valor positiu fins a 255   -   0->Si s desconegut");
	do
	{ gotoxy(40,20); i = scanf ("%lu",&auxlong); neteja_stdin(); }
	while (i == 0 || auxlong<0 || auxlong>255);
	p->alt=auxlong;
	/* En aquest cas, la utilitzaci de la variable auxlong s per recollir el valor
	   que introdueixi l'usuari, que pot ser superior a 255. Si ho fssim direc-
	   tament amb la variable &p->alt, en ser un unsigned char, si l'usuari entra
	   un valor superior a 255, el llenguatge C en fa el mdul 255 i es queda amb
	   el residu... No ens interessa!!! */

	netejar_missatge();
}

void outputPersonaFor (struct t_persona p)
{
	pantallaPersona();
	gotoxy(40,8); printf ("%s",p.nif);
	gotoxy(40,10); printf ("%s",p.cognom1);
	gotoxy(40,12); printf ("%s",p.cognom2);
	gotoxy(40,14); printf ("%s",p.nom);
	gotoxy(40,16); outputData (p.data_naix);
	gotoxy(40,18); printf ("%g",p.pes);
	gotoxy(40,20); printf ("%u",p.alt);
}

void outputPersonaTab (unsigned char fil, struct t_persona p)
{
	gotoxy(1,fil);
	printf ("%-9s %-20s %-20s %-15s ", p.nif, p.cognom1, p.cognom2, p.nom);
	outputData (p.data_naix);
}

char *getPersonaNif (struct t_persona *p)
{	return p->nif; }

char *getPersonaCognom1 (struct t_persona *p)
{	return p->cognom1; }

char *getPersonaCognom2 (struct t_persona *p)
{	return p->cognom2; }

char *getPersonaNom (struct t_persona *p)
{	
	return p->nom; 
}

struct t_data getPersonaDataNaix (struct t_persona *p)
{	return p->data_naix; }

double getPersonaPes (struct t_persona *p)
{	return p->pes; }

int getPersonaAlt (struct t_persona *p)
{	return p->alt; }

int setPersonaNif (struct t_persona *p, char *nouNif)
{
	if (strlen(nouNif)>9) return 0; 
	strcat(p->nif,nouNif); 
	return 1;
}

int setPersonaCognom1 (struct t_persona *p, char *nouCognom1)
{
	if (strlen(nouCognom1)>20) return 0;
	strcat(p->cognom1,nouCognom1); 
	return 1;
}

int setPersonaCognom2 (struct t_persona *p, char *nouCognom2)
{
	if (strlen(nouCognom2)>20) return 0;
	strcat(p->cognom2,nouCognom2); 
	return 1;
}

int setPersonaNom (struct t_persona *p, char *nouNom)
{
	if (strlen(nouNom)>15) return 0;
	strcat(p->nom,nouNom); 
	return 1;
}

int setPersonaDataNaix (struct t_persona *p, struct t_data novaDataNaix)
{
	if (!dataOK(novaDataNaix.dia,novaDataNaix.mes,novaDataNaix.any)) return 0;
	p->data_naix=novaDataNaix;
	return 1;
}

int setPersonaPes (struct t_persona *p, double nouPes)
{
	if (nouPes<0) return 0;
	p->pes = nouPes;
	return 1;
}

int setPersonaAlt (struct t_persona *p, int novaAlt)
{
	if (novaAlt<0 || novaAlt>255) return 0;
	p->alt = novaAlt;
	return 1;
}
