/* Fitxer: persona2.h
   Descripci: Definici del tipus de dada "persona" i declaraci de les funcions
               per gestionar-la.
   Autor: Isidre Guix
*/

#ifndef __PERSONA__H__
#define __PERSONA__H__

#include "data1.h"

struct t_persona
{
	char nif[10];
	char cognom1[21], cognom2[21], nom[16];
	struct t_data data_naix;
	double pes;
	unsigned char alt;		/* Sense decimals - Ning passa dels 255 cm, no? */
};

void pantallaPersona();
/*  Situa els ttols dels diferents camps en una pantalla */

void inputPersona (struct t_persona *p);
/*	Efectua la lectura de les dades d'una persona per l'entrada estndard */

void inputPersonaNomesNif (struct t_persona *p);
/*  Efectua la lectura del nif d'una persona per l'entrada estndard, en el
    formulari de captura de dades d'una persona */

void inputPersonaSenseNif (struct t_persona *p);
/*  Efectua la lectura de totes les dades d'una persona menys el dni, per l'en-
    trada estndard, suposant que el formulari de captura de dades ja s visua-
    litzat */

void outputPersonaFor (struct t_persona p);
/*	Visualitza una persona per la sortida estndard, en format formulari */

void outputPersonaTab (unsigned char fil, struct t_persona p);
/*	Visualitza una persona per la sortida estndard, en format tabular, 
    a la fila que indica l'argument "fil" */

char *getPersonaNif (struct t_persona *p);
/* 	Retorna el Nif de la persona */

char *getPersonaCognom1 (struct t_persona *p);
/*	Retorna el Cognom1 de la persona */

char *getPersonaCognom2 (struct t_persona *p);
/*	Retorna el Cognom2 de la persona */

char *getPersonaNom (struct t_persona *p);
/*	Retorna el Nom de la persona */

struct t_data getPersonaDataNaix (struct t_persona *p);
/*	Retorna la Data de Naixement de la persona */

double getPersonaPes (struct t_persona *p);
/*	Retorna el pes de la persona */

int getPersonaAlt (struct t_persona *p);
/*	Retorna l'alada de la persona */

int setPersonaNif (struct t_persona *p, char *nouNif);
/* 	Intenta modificar el NIF de la persona.
	Retorna 1: Nou NIF correcte
			0: Nou NIF erroni - No s'ha modificat
*/

int setPersonaCognom1 (struct t_persona *p, char *nouCognom1);
/*	Intenta modificar el Cognom1 de la persona.
	Retorna 1: Nou Cognom1 correcte
			0: Nou Cognom1 erroni - No s'ha modificat 
*/

int setPersonaCognom2 (struct t_persona *p, char *nouCognom2);
/*	Intenta modificar el Cognom2 de la persona.
	Retorna 1: Nou Cognom2 correcte
			0: Nou Cognom2 erroni - No s'ha modificat 
*/

int setPersonaNom (struct t_persona *p, char *nouNom);
/*	Intenta modificar el nom de la persona.
	Retorna 1: Nou nom correcte
			0: Nou nom erroni - No s'ha modificat 
*/

int setPersonaDataNaix (struct t_persona *p, struct t_data novaDataNaix);
/*	Intenta modificar la Data de Naixement de la persona.
	Retorna 1: Nova data correcta
			0: Nova data errnia - No s'ha modificat
*/

int setPersonaPes (struct t_persona *p, double nouPes);
/*	Intenta modificar el pes de la persona.
	Retorna 1: Nou pes correcte
			0: Nou pes erroni - No s'ha modificat
*/

int setPersonaAlt (struct t_persona *p, int novaAlt);
/*	Intenta modificar l'alada de la persona.
	Retorna 1: Nova alada correcta
			0: Nova alada errnia - No s'ha modificat
*/

#endif
