/* Programa : u6n2p01.c
	Descripci: Programa per omplir l'arxiu Btrieve PERSONES.BTR amb dades
					prenent per cognoms i noms a partir dels arxius COGNOMS.TXT i
					NOMS.TXT
	Autor: Isidre Guix
*/

#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>

#include "verscomp.h"
#include "generic2.h"
#include "persona2.h"

#include "turcbtrv.c"

#define MAXCOGNOM 24 /* Nombre de cognoms del fitxer COGNOMS.TXT */
#define MAXNOM 24 /* Nombre de noms del fitxer NOMS.TXT */

char fper[128];
int lper;
struct t_persona rper;
char nom[]="PERSONES.BTR";

void obrir_fitxer()
{
	int error;
	char pas[]="";
	int lpas=0;

	error=BTRV(0,fper,pas,&lpas,nom,0);
	if (error)
	{
		char s[80];
		sprintf(s,"Error %d en obrir el fitxer %s. ",error,nom);
		missatge_ae(s);
		exit(1);
	}
}

void tancar_fitxer()
{
	int error;
	error=BTRV(1,fper);
	if (error)
	{
		char s[80];
		sprintf(s,"Error %d en tancar el fitxer %s. ",error,nom);
		missatge_ae(s);
		exit(1);
	}
}

void main()
{
	unsigned int nI,nJ,nK,error,nErr;
	FILE *fnom, *fcognom;
	unsigned int nreg;	/* Nombre de registres a insertar */
	char clau0[10];

	clrscr(); nErr = 0;

	if ((fnom=fopen("noms.txt","rt"))==NULL)
	{
		missatge_ae("Error en obrir el fitxer NOMS.TXT. ");
		exit (1);
	}

	if ((fcognom=fopen("cognoms.txt","rt"))==NULL)
	{
		missatge_ae("Error en obrir el fitxer COGNOMS.TXT. ");
		exit (1);
	}

	/* Efectuem obertura en mode text perque el llenguatge transformi la
	possible parella CR+LF de final de lnia dels fitxers textuals en un nic
	carcter \n */

	randomize();
	obrir_fitxer();
	gotoxy (5,5); printf ("Quants registres vol insertar?");
	do
	{ gotoxy (36,5);nI=scanf("%u",&nreg);fflush(stdin);} while (nI==0);
	gotoxy (5,7); printf ("Registres inserits:");
	gotoxy (5,9); printf ("Intents d'inserci erronis per duplicat de nif:");

	for(nI=0;nI<nreg;)
	{
		/* Construcci aleatria del nif */
		nJ=1+random(8);strcpy(rper.nif,"000000000");
		for(nK=9-nJ;nK<=8;nK++) rper.nif[nK]=48+random(10);

		/* Construcci aleatria del cognom1 a partir del fitxer de cognoms */
		nJ=random(MAXCOGNOM); rewind(fcognom);
		for (nK=0;nK<nJ; nK++) fgets(rper.cognom1,21,fcognom);
		fgets(rper.cognom1,21,fcognom);
		rper.cognom1[strlen(rper.cognom1)-1]='\0';

		/* Construcci aleatria del cognom1 a partir del fitxer de cognoms */
		nJ=random(MAXCOGNOM); rewind(fcognom);
		for (nK=0;nK<nJ; nK++) fgets(rper.cognom2,21,fcognom);
		fgets(rper.cognom2,21,fcognom);
		rper.cognom2[strlen(rper.cognom2)-1]='\0';

		/* Construcci aleatria del cognom1 a partir del fitxer de cognoms */
		nJ=random(MAXNOM); rewind(fnom);
		for (nK=0;nK<nJ; nK++) fgets(rper.nom,sizeof(rper.nom)-1,fnom);
		fgets(rper.nom,16,fnom);
		rper.nom[strlen(rper.nom)-1]='\0';

		/* Construcci aleatria de la data de naixement */
		rper.data_naix.any=1900+random(100);
		rper.data_naix.mes=(unsigned)(1+random(12));
		rper.data_naix.dia=(unsigned)(1+random(27));

		/* Construcci aleatria del pes i de l'alada */
		rper.pes=random(256);
		rper.alt=random(256);

		lper=sizeof(rper);
		error=BTRV(2,fper,&rper,&lper,clau0,0);
		switch (error)
		{
			char s[80];
			case 0: nI++; gotoxy (28,7); printf ("%d",nI); break;
			case 5: nErr++; gotoxy (55,9); printf ("%d",nErr); break;
			otherwise:
				sprintf(s,"Error %d en insertar al fitxer %s.",error,nom);
				missatge_ae(s);
		}
	}
	tancar_fitxer();
	missatge_ae("Programa finalitzat.");
	clrscr();
}